#include "descriptor/descriptor.h"
#include <string.h>
#include <stdio.h>

int main(void)
{
	ITEM scena, std_attribute;

	/***** Piani Scena ****/
	ITEM sfondo, terra, lago, strada;
	ITEM pianiscena; //Lista dei Piani della scena
	ITEM terratext, lagotext;/*attributi piani scena*/
	/*---------------*/

	/***** Casa ****/
	ITEM base, tetto1, tetto2;
	ITEM casa; //Lista della Casa
	ITEM casatext, casatext2, tettocasa; /* attributi casa*/
	/*---------------*/

	/***** Finestre ****/

	ITEM vetrispenti, vetriill, vetrifbasse, stipitifalte, stipitifalte2, stipitifbasse, stipitifbasse2, cardini, davanzali;
	ITEM finestre; /* lista */
	ITEM lucespenta, luceaccesa, stipite, stipitescuri, dav1, dav2, dav3, dav4, cardine; /* attributi finestre*/
	/*---------------*/

	/***** Cancello ****/
	ITEM colonne, portacancello;
	ITEM cancello; //Lista cancello
	ITEM canctext; /* attributi cancello*/
	/*---------------*/

	/***** Lampione ****/
	ITEM struttura, vetri;
	ITEM lampione; //Lista vetri
	ITEM vetrolamp, structlamp; /* attributi lampione */
	/*---------------*/

	/***** MuroLaterale ****/

	ITEM muro;
	/*---------------*/

	/***** Congiunzioni ****/

	ITEM colleg;
	ITEM muri; 	//Lista muri in scena
	/*---------------*/

	/***** Pietra ****/

	ITEM pietra;
	/*---------------*/
	
	/***** Marciapiede ****/

	ITEM marciapiede;
	ITEM marciapiedetext; /* attributi marciapiede */
	/*---------------*/

	/**** Setto luce ambiente, backgrount, camera ****/
	set_background(0.1098, 0.1411, 0.1294, TRUE);
	set_ambient_light(0.9372, 0.9215, 0.9529, 0.5355);
	create_point_light(-14.04235 ,0.78271, 9.51975, 0.9411, 1, 1, 1, 1, "sun");
	
	/************ Setto gli Attributi *************/
	/**** Attributo standard ****/
	std_attribute = create_attribute("std_attribute");
	set_color(std_attribute,  1, 1, 1, 0, 1);
	set_reflectivity(std_attribute, 0, 2);
	set_transparency(std_attribute, 0, 0, 0, 1);
	/**** terra ****/	
	terratext = create_attribute("terra");
	set_color(terratext,  0.2823, 0.2274, 0.1803, 0.5, 0.28464);
	set_reflectivity(terratext, 0.01, 2);
	set_transparency(terratext, 0, 0, 0, 1);
	/**** lago ****/	
	lagotext = create_attribute("lago");
	set_color(lagotext, 0.2156, 0.1882, 0.1607, 0.23, 0.38564);
	set_reflectivity(lagotext, 0.66, 2);
	set_transparency(lagotext, 0.14, 0.05, 0, 1.33);
	/**** casatext ****/	
	casatext = create_attribute("casatext");
	set_color(casatext, 0.8549, 0.8274, 0.6901, 0.83, 0.23873);
	set_reflectivity(casatext, 0, 2);
	set_transparency(casatext, 0, 0, 0, 0.283);
	/**** casatext2 ****/	
	casatext2 = create_attribute("casatext2");
	set_color(casatext2, 0.8666, 0.8274, 0.6901, 0.77, 0.29382);
	set_reflectivity(casatext2, 0, 2);
	set_transparency(casatext2, 0, 0, 0, 0.367);
	/**** tettocasa ****/	
	tettocasa = create_attribute("tettocasa");
	set_color(tettocasa,  0.1568, 0.1215, 0.0627, 1, 0.72536);
	set_reflectivity(tettocasa, 0, 2);
	set_transparency(tettocasa, 0, 0, 0, 2.378);
	/**** lucespenta ****/	
	lucespenta = create_attribute("lucespenta");
	set_color(lucespenta,  0.3921, 0.345, 0.1254, 0.42, 0.404);
	set_reflectivity(lucespenta, 0.32, 2);
	set_transparency(lucespenta, 0.4, 0.24, 0, 1.652);
	/**** luceaccesa ****/	
	luceaccesa = create_attribute("luceaccesa");
	set_color(luceaccesa,  0.945, 0.5843, 0.4039, 1, 0.606);
	set_reflectivity(luceaccesa, 0.12, 2);
	set_transparency(luceaccesa, 0.83, 0.7, 2, 1.744);
	/**** stipite ****/	
	stipite = create_attribute("stipite");
	set_color(stipite,  0.3411, 0.3294, 0.1254, 0.37, 0.53255);
	set_reflectivity(stipite, 0.02, 2);
	set_transparency(stipite, 0, 0, 0, 1.285);
	/**** stipitescuri ****/	
	stipitescuri = create_attribute("stipitescuri");
	set_color(stipitescuri,  0.345, 0.3294, 0.1254, 0.78, 0.49582);
	set_reflectivity(stipitescuri, 0.01, 2);
	set_transparency(stipitescuri, 0, 0, 0, 0.459);
	/**** dav1 ****/	
	dav1 = create_attribute("dav1");
	set_color(dav1,  0.2431, 0.2392, 0.1686, 0.54, 0.34891);
	set_reflectivity(dav1, 0.02, 2);
	set_transparency(dav1, 0, 0, 0, 1);
	/**** dav2 ****/	
	dav2 = create_attribute("dav2");
	set_color(dav2,  0.2117, 0.2039, 0.145, 0.650, 0.67027);
	set_reflectivity(dav2, 0.06, 2);
	set_transparency(dav2, 0, 0, 0, 1);
	/**** dav3 ****/	
	dav3 = create_attribute("dav3");
	set_color(dav3,  0.1725, 0.149, 0.0941, 0.720, 0.37645);
	set_reflectivity(dav3, 0.1, 2);
	set_transparency(dav3, 0, 0, 0, 1);
	/**** dav4 ****/
	dav4 = create_attribute("dav4");
	set_color(dav4,  0.1215, 0.0862, 0.0392, 0.660, 0.22955);
	set_reflectivity(dav4, 0.230, 2);
	set_transparency(dav4, 0, 0, 0, 0.642);
	/**** cardine ****/	
	cardine = create_attribute("cardine");
	set_color(cardine, 0.1686, 0.1568, 0.149, 0, 0.8);
	set_reflectivity(cardine, 0, 2);
	set_transparency(cardine, 0, 0, 0, 1);
	/**** canctext ****/	
	canctext = create_attribute("canctext");
	set_color(canctext, 0.8549, 0.8274, 0.6901, 0.79, 0.44073);
	set_reflectivity(canctext, 0.16, 2);
	set_transparency(canctext, 0, 0, 0, 1.744);
	/**** vetrolamp ****/	
	vetrolamp = create_attribute("vetrolamp");
	set_color(vetrolamp, 0.8117, 0.8745, 0.8, 0.52, 0.505);
	set_reflectivity(vetrolamp, 0.11, 2);
	set_transparency(vetrolamp, 0.89, 0.64, 0, 1.269);
	/**** structlamp ****/	
	structlamp = create_attribute("structlamp");
	set_color(structlamp, 0.2392, 0.2196, 0.2274, 0.51, 0.35809);
	set_reflectivity(structlamp, 0.170, 2);
	set_transparency(structlamp, 0, 0, 0, 1);
	/**** marciapiedetext ****/	
	marciapiedetext = create_attribute("marciapiedetext");
	set_color(marciapiedetext, 0.4274, 0.3647, 0.3372, 0.15, 0.12855);
	set_reflectivity(marciapiedetext, 0.02, 2);
	set_transparency(marciapiedetext, 0, 0, 0, 1);

	/************* LUCI *************/
	// lampione
	create_warn_light(2.1, 1.92, 0.45, -0.0999971, 0.003231, -0.00687, 0.7098, 0.7843, 0.8667, 1, 1.4, 0, 42.81818, FALSE, 0, 0, 0, 0, "luceLamp1");
	create_warn_light(1.857, 1.92, 0.71, -0.978616, -0152355, 0.138193, 0.8509, 0.8431, 0.8431, 1.2, 0, 0, 180, FALSE, 0, 0, 0, 0, "luceLamp2");
	create_warn_light(1.717716, 1.899508, 0.1, -0.295725, 0.04594, 0.954168, 0.945, 0.7098, 0.4588, 5.7273, 0.75, 0, 25.16162, FALSE, 0, 0, 0, 0, "luceLamp3");
	create_warn_light(1.86, 1.92, 0.71, -0.987758, -0.073486, 0.137597, 0.945, 0.7098, 0.4588, 4.1515, 0.75, 0, 82.77778, FALSE, 0, 0, 0, 0, "luceLamp4");
	create_warn_light(1.9095, 1.92, 0.69, -0.978412, -0.149147, 0.143056, 0.8666, 0.745, 0.3294, 54.05051, 0, 0, 180, FALSE, 0, 0, 0, 0, "luceLampInterna");
	//F11
	create_warn_light(1.52725, 0.735, 1.4247, -0.924381, 0.346882, -0.15872, 0.945, 0.5843, 0.4039, 30.93939, 1, 0, 156.1919, FALSE, 0, 0, 0, 0, "luceF11A1");
	create_warn_light(1.52725, 0.865, 1.4247, -0.941424, 0.295959, -0.161646, 0.945, 0.5843, 0.4039, 23.58586, 1, 0, 156.1919, FALSE, 0, 0, 0, 0, "luceF11A2");
	//F12
	create_warn_light(1.52725, 0.285, 1.4247, -0.959814, 0.248194, -0.130982, 0.9411, 0.5843, 0.4039, 23.58586, 1, 0, 156.1919, FALSE, 0, 0, 0, 0, "luceF12A1");
	create_warn_light(1.52725, 0.415, 1.4247, -0.875271, 0.459684, -0.150304, 0.9411, 0.5843, 0.4039, 30.41414, 1, 0, 156.1919, FALSE, 0, 0, 0, 0, "luceF12A2");



	/***** Piani Scena ****/
	sfondo = read_nurbs("sfondoScena.db");
	terra = read_nurbs("terraScena.db");
	lago = read_nurbs("lago.db");
	strada = read_nurbs("strada.db");
	pietra = read_nurbs("pietra.db");
	marciapiede = read_obj("marciapiede.obj", "Marciapiede");
	
	//setto le texture
	set_domain_texture(sfondo, std_attribute, "texture/sfondo.hr", 0, 1, 0, 1, FALSE, 0.82, 0.3);
	set_domain_texture(terra, terratext, "texture/erba.hr", 0, 0.2, 0, 0.2, TRUE, 0.2, 0.2);
	set_domain_texture(pietra, casatext, "texture/pietra.hr", 0, 0.1, 0, 0.9, TRUE, 0.4, 0.8);
	set_bump_texture(lago, lagotext, "texture/muro.hr", 0, 0.1, 0 , 0.2, TRUE, 0.035, 1);
	set_bump_texture(strada, terratext, "texture/erba.hr", 0, 0.1, 0 , 0.2, TRUE, 0.8, 1);
	
	//aggiungo l' attributo
	set_attribute(marciapiede, marciapiedetext);

	// Creo la lista Piani Scena
	pianiscena = create_list(sfondo, "PianiScena");
	pianiscena = insert_in_list(pianiscena, terra);
	pianiscena = insert_in_list(pianiscena, lago);
	pianiscena = insert_in_list(pianiscena, strada);
	pianiscena = insert_in_list(pianiscena, pietra);
	pianiscena = insert_in_list(pianiscena, marciapiede);
	/*---------------*/

	/***** Casa ****/
	base = read_nurbs("baseCasa.db");
	tetto1 = read_nurbs("tettoCamp.db");
	tetto2 = read_nurbs("tettoCasa.db");

	//setto le texture
	set_bump_texture(base, casatext2, "texture/muro.hr", 0, 0.035, 0 , 0.035, TRUE, 0.2, 1);

	//aggiungo l' attributo
	set_attribute(tetto1, tettocasa);
	set_attribute(tetto2, tettocasa);

	//Creo la lista della Casa
	casa = create_list(base, "Casa");
	casa = insert_in_list(casa, tetto1);
	casa = insert_in_list(casa, tetto2);
	/*---------------*/

	/***** Muri in Scena ****/

	muro = read_nurbs("muroLaterale.db");
	colleg = read_obj("congiunzioni.obj", "Congiunzioni");
	
	//Creo la lista Muri in Scena
	muri = create_list(muro, "MuriScena");
	muri = insert_in_list(muri, colleg);

	//setto le texture
	set_weighted_rand_texture(muri, casatext, casatext2, std_attribute, std_attribute, 20, 80, 0, 0);
	/*---------------*/

	/***** Cancello ****/
	colonne = read_obj("colonneCanc.obj", "Colonne");
	portacancello = read_obj("porteCanc.obj", "PorteCancello");

	//Setto gli attributi 
	set_attribute(portacancello, canctext);

	//setto le texture
	set_weighted_rand_texture(colonne, casatext, casatext2, std_attribute, std_attribute, 20, 80, 0, 0);

	//Creo la lista cancello
	cancello = create_list(colonne, "Cancello");
	cancello = insert_in_list(cancello, portacancello);
	/*---------------*/
	
	/***** Lampione ****/
	struttura = read_obj("strutturaLamp.obj", "StrutturaLamp");
	vetri = read_obj("vetriLamp.obj", "VetriLamp");
	
	//Setto gli attributi
	set_attribute(struttura, structlamp);
	set_attribute(vetri, vetrolamp);

	//Creo la lista vetri
	lampione  = create_list(struttura, "Lampione");
	lampione = insert_in_list(lampione, vetri);
	/*---------------*/
	
	/***** Finestre ****/
	vetrispenti = read_obj("vetriFalte.obj", "Vetrispenti");
	vetriill = read_obj("vetriFalteIll.obj", "Vetriill");
	vetrifbasse = read_obj("vetriFbasse.obj", "Vetrifbasse");
	stipitifalte = read_obj("stipitiFalte.obj", "Stipitifalte");
	stipitifalte2 = read_obj("stipitiFalte2.obj", "Stipitifalte2");
	stipitifbasse = read_obj("stipitiFbasse.obj", "Stipitifbasse");
	stipitifbasse2 = read_obj("stipitiFbasse2.obj", "Stipitifbasse2");
	cardini = read_obj("cardini.obj", "Cardini");
	davanzali = read_obj("davanzali.obj", "Davanzali");
	
	//setto le texture
	set_domain_texture(vetrifbasse, dav1, "texture/Scuro.hr", 0, 1, 0, 1, FALSE, 1, 0.6);
	set_weighted_rand_texture(davanzali, dav1, dav2, dav3, dav4, 7, 23, 30, 40);

	//Setto gli attributi 
	set_attribute(vetrispenti, lucespenta);
	set_attribute(vetriill, luceaccesa);
	set_attribute(stipitifalte, stipite);
	set_attribute(stipitifalte2, stipite);
	set_attribute(stipitifbasse, stipitescuri);
	set_attribute(stipitifbasse2, stipitescuri);
	set_attribute(cardini, cardine);

	//Creo la lista vetri
	finestre  = create_list(vetrispenti, "Finestre");
	finestre = insert_in_list(finestre, vetriill);
	finestre = insert_in_list(finestre, vetrifbasse);
	finestre = insert_in_list(finestre, stipitifalte);
	finestre = insert_in_list(finestre, stipitifalte2);
	finestre = insert_in_list(finestre, stipitifbasse);
	finestre = insert_in_list(finestre, stipitifbasse2);
	finestre = insert_in_list(finestre, cardini);
	finestre = insert_in_list(finestre, davanzali);
	/*---------------*/

	/**************** CREAZIONE SCENA ******************/
	scena = create_list(pianiscena ,"Scena");
	scena = insert_in_list(scena, casa);
	scena = insert_in_list(scena, muri);
	scena = insert_in_list(scena, cancello);
	scena = insert_in_list(scena, lampione);
	scena = insert_in_list(scena, finestre);
	
	save_scene("ImperoDelleLuci.md", "ImperoDelleLuci", scena);
	return(0);
}
